<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmCommon: kmCommon Library</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">kmCommon
   </div>
   <div id="projectbrief">kmCommon library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('md__c_1__d_drive__development__a_v_r__workspace__atmel_studio7_km_avr_tests_km_debug_test_km_common__r_e_a_d_m_e.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">kmCommon Library </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>This repository contains the kmCommon library, a generic common file for AVR MCUs and also kmCommonDefs, a collection of useful macros for value manipulation and calculations. It also includes constants and conversion factors for time and bit manipulation.</p>
<h2>Overview</h2>
<p>The <code>kmCommon</code> library provides generic common files of <em>kmFramework</em> for AVR microcontrollers. The <code>kmCommonDefs</code> provides macros for value manipulation, such as getting the string representation of a value, finding the minimum and maximum of two values, and clamping a value within a specified range. It also includes definitions of various constants and conversion factors commonly used for bit manipulation and time conversions.</p>
<h3>Contents</h3>
<ul>
<li><a class="el" href="km_common_8h.html">kmCommon.h</a></li>
<li><a class="el" href="km_common_defs_8h.html" title="Useful macros for value manipulation and calculations. Constants and conversion factors for use in ti...">kmCommonDefs.h</a></li>
<li><a class="el" href="km_config_8h.html" title="Generic configuration. kmConfig.h.">kmConfig.h</a></li>
</ul>
<h2>Installation</h2>
<p>To include the <code>kmCommon</code> library in your own project as a submodule, use the following command: </p><div class="fragment"><div class="line">git submodule add git@gitlab.com:c-mos/kmAvrLibs/kmCommon.git</div></div><!-- fragment --><p> Example Usage: </p><div class="fragment"><div class="line"><span class="preprocessor">#include &lt;stdlib.h&gt;</span></div><div class="line"><span class="preprocessor">#include &lt;stdio.h&gt;</span></div><div class="line"><span class="preprocessor">#include &lt;stdbool.h&gt;</span></div><div class="line"><span class="preprocessor">#include &lt;util/delay.h&gt;</span></div><div class="line"></div><div class="line"><span class="preprocessor">#include &quot;<a class="code" href="km_common_8h.html">kmCommon/kmCommon.h</a>&quot;</span></div><div class="line"></div><div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">void</span>) {</div><div class="line">    <span class="comment">// Example usage of macros</span></div><div class="line">    uint8_t a = 5;</div><div class="line">    uint8_t b = 10;</div><div class="line">    uint8_t c = <a class="code" href="km_common_defs_8h.html#af4ae2bd7db4825524ef32840b10ed3ff">KMC_MIN</a>(a, b);</div><div class="line">    uint8_t d = <a class="code" href="km_common_defs_8h.html#adc81a21527ba9134193dd6edc7a714a1">KMC_MAX</a>(a, b);</div><div class="line">    </div><div class="line">    <span class="keywordflow">while</span>(<span class="keyword">true</span>) {</div><div class="line">    }</div><div class="line">}</div></div><!-- fragment --><h3>License</h3>
<p>This project is licensed under the GNU General Public License version 3.0 or later. See the <a href="https://www.gnu.org/licenses/">LICENSE</a> file for details. </p>
</div></div><!-- PageDoc -->
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.15 </li>
  </ul>
</div>
</body>
</html>
